unit KDSSV;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, KDSContainerUnit1, DBXJSON, Generics.Collections, DB, ActnList,
  PlatformDefaultStyleActnCtrls, ActnMan, CategoryButtons, ExtCtrls, DBClient,
  JFXMLParse, Grids, Wwdbigrd, Wwdbgrid, POSDBGrid ;

type
  TForm1 = class(TForm)
    TA: TClientDataSet;
    TAs: TDataSource;
    TBs: TDataSource;
    CategoryPanelGroup1: TCategoryPanelGroup;
    CategoryPanel1: TCategoryPanel;
    CategoryPanel2: TCategoryPanel;
    cb1: TCategoryButtons;
    ActionManager: TActionManager;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    TATA001: TStringField;
    TATA002: TStringField;
    TATA003: TStringField;
    TATA006: TStringField;
    TATableNo: TStringField;
    TADeliveryType: TStringField;
    TB: TClientDataSet;
    TBTB001: TStringField;
    TBTB002: TStringField;
    TBTB003: TStringField;
    TBTB006: TStringField;
    TBPluName: TStringField;
    TBSaleQty: TFloatField;
    TBDoItemOK: TStringField;
    gridTA: TPOSDBGrid;
    gridTB: TPOSDBGrid;
    procedure Action2Execute(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  KDSChannel = 'KDSChannel';

implementation

{$R *.dfm}

procedure TForm1.Action1Execute(Sender: TObject);
VAR
  mSR  : TSearchRec;
  xXmlNode:TJFXmlParse;
  mFileName : Array[0..MAX_PATH] OF WideChar;
  mdirPath, mFilePath, mFileNames:string;
  mList:TstringList;
  mTA001,  mTA002,  mTA003,  mTA006 : String;
  mInt, FCount, i:integer;

  function GetNodeValue(xStr:String):String;
  begin
    if xXmlNode.IsExistNode(xStr) then
    begin
      if (xXmlNode.MoveTo(xStr, false)) then
        Result := xXmlNode.Value;
      xXmlNode.MoveUp ;
    end;
  end;

begin
  { TODO : }leǳưʧ@ }
  mList := TStringList.Create;

  { TODO : o| ]OIIS ΧOبk }
  GetModuleFileName(HInstance, @mFileName, MAX_PATH);
  mdirPath := IncludeTrailingBackslash(ExtractFilePath(mFileName));

  mInt := FindFirst(mdirPath+'KDS\Before\*.xml', faAnyFile, mSR);
  try
    while mInt = 0 do
    begin
      mFilePath := mdirPath + 'KDS\Before\' + mSR.Name;
      //᭱hƻݭn
      mFileNames := mSR.Name;

      { TODO : }l }
      try
        xXmlNode := TJFXmlParse.Create;
        xXmlNode := xXmlNode.LoadXMLFromFile(mFilePath);

        { TODO 1 -o01753 : BzTA }
        if xXmlNode.MoveTo('Order', false) then
        begin
          Ta.Append;
          if xXmlNode.MoveTo('header', false) then
          begin
            mTA001 := GetNodeValue('TA001');
            mTA002 := GetNodeValue('TA002');
            mTA003 := GetNodeValue('TA003');
            mTA006 := GetNodeValue('TxNo');

            Ta.FieldbyName('TA001').AsString := mTA001;
            Ta.FieldbyName('TA002').AsString := mTA002;
            Ta.FieldbyName('TA003').AsString := mTA003;
            Ta.FieldbyName('TableNo').AsString := GetNodeValue('TableNo');
            Ta.FieldbyName('TA006').AsString := mTA006;
            Ta.FieldbyName('DeliveryType').AsString := GetNodeValue('DeliveryType');
            xXmlNode.Moveup;
          end;
        end;

        { TODO 2 -o01753 : BzTB }

        if xXmlNode.MoveTo('Detail', false) then
        begin
          xXmlNode.GetNodeList(mList);
          FCount := mList.Count;
          for i := 1 to FCount  do
          begin
            TB.Append;
            if xXmlNode.MoveTo('item', false) then
            begin
              TB.FieldbyName('TB001').AsString := mTA001;
              TB.FieldbyName('TB002').AsString := mTA002;
              TB.FieldbyName('TB003').AsString := mTA003;
              TB.FieldbyName('TB006').AsString := mTA006;
              TB.FieldbyName('PluName').AsString := GetNodeValue('PluName');
              TB.FieldbyName('SaleQty').AsString := GetNodeValue('SaleQty');
              TB.FieldbyName('DoItemOK').AsString := GetNodeValue('DoItemOK');
            end;
            TB.Post;
            xXmlNode.MoveSibling;
          end;
        end;
        Ta.Post;
        TB.MasterFields := 'TA001;TA002;TA003;TA006';

        { TODO : xs\ ha }
        MoveFile(PChar(mFilePath), PChar(mdirPath+'\KDS\AFTER\'+mFileNames));

        { TODO : U@ɮ }
        mInt := FindNext(mSR);
      except


      end;
    end;
  finally
    FindClose(mSR);
    mList.Free;
    xXmlNode.Free;
  end;
end;

procedure TForm1.Action2Execute(Sender: TObject);
var
  vMessage : TJSONString;
begin
  vMessage := TJSONString.Create('reset');
  ServerContainer1.DSServer1.BroadcastMessage(KDSChannel, vMessage);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TA.CreateDataSet;
  TB.CreateDataSet;
end;

end.

