unit KDSSet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, StdCtrls, pngimage, ExtCtrls, CategoryButtons, ActnList,
  inifiles;

type
  TKDSOption = class(TForm)
    CategoryButtons1: TCategoryButtons;
    Panel1: TPanel;
    Panel3: TPanel;
    Image2: TImage;
    KDSTitle: TLabel;
    Image1: TImage;
    Image3: TImage;
    Image4: TImage;
    ImageIcon: TImageList;
    ActionList: TActionList;
    actSET: TAction;
    actOption: TAction;
    plConstant: TPanel;
    Shape1: TShape;
    Label1: TLabel;
    Shape2: TShape;
    Label2: TLabel;
    Shape3: TShape;
    cb1: TComboBox;
    ck1: TCheckBox;
    Label4: TLabel;
    cb2: TComboBox;
    ed1: TEdit;
    Shape4: TShape;
    Yes: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure LoadIni;
    procedure ReadIni;
    procedure YesClick(Sender: TObject);
    procedure cb2Change(Sender: TObject);

  private
    { Private declarations }
  public
    F1,F2,F3,F4,F5,F6 :String;
    { Public declarations }
  end;

var
  KDSOption: TKDSOption;

implementation

{$R *.dfm}

procedure TKDSOption.cb2Change(Sender: TObject);
begin
  case cb2.ItemIndex of
    0: ed1.text := F1;
    1: ed1.text := F2;
    2: ed1.text := F3;
    3: ed1.text := F4;
    4: ed1.text := F5;
    5: ed1.text := F6;
  end;

end;

procedure TKDSOption.FormCreate(Sender: TObject);
begin
  //JC
  ReadIni;


end;

procedure TKDSOption.Image3Click(Sender: TObject);
begin
  close;
end;

procedure TKDSOption.LoadIni;
var
  mPos: TIniFile;
  sCurrentDir:string;
begin
  sCurrentDir := GetCurrentDir;
  mPos := TIniFile.create(sCurrentDir+'\Set.ini');
  with mPos do
  try
    WriteInteger('SET', 'Template', cb1.Items.IndexOf(cb1.Text));
    WriteBool('SET', 'MainStation', ck1.checked);
    WriteInteger('SET', 'WindowsShot', cb2.Items.IndexOf(cb2.Text));
    WriteString('Windows', 'Name1', F1);
    WriteString('Windows', 'Name2', F2);
    WriteString('Windows', 'Name3', F3);
    WriteString('Windows', 'Name4', F4);
    WriteString('Windows', 'Name5', F5);
    WriteString('Windows', 'Name6', F6);
  finally
    mPos.free;
  end;
end;

procedure TKDSOption.ReadIni;
var
  mPos: TIniFile;
  sCurrentDir:string;
begin
  sCurrentDir := GetCurrentDir;
  mPos := TIniFile.create(sCurrentDir+'\Set.ini');
  with mPos do
  try
    cb1.ItemIndex := ReadInteger('SET', 'Template', 0);
    ck1.Checked := ReadBool('SET','MainStation', True);
    cb2.ItemIndex := ReadInteger('SET', 'WindowsShot', 0);

    F1:=  ReadString('Windows', 'Name1', '1');
    F2:=  ReadString('Windows', 'Name2', '2');
    F3:=  ReadString('Windows', 'Name3', '3');
    F4:=  ReadString('Windows', 'Name4', '4');
    F5:=  ReadString('Windows', 'Name5', '5');
    F6:=  ReadString('Windows', 'Name6', '6');

//    cB2.Items.Clear;
//    cb2.Items.Add(F1);    cb2.Items.Add(F2);    cb2.Items.Add(F3);    cb2.Items.Add(F4);    cb2.Items.Add(F5);    cb2.Items.Add(F6);
  finally
    mPos.free;
  end;
end;

procedure TKDSOption.YesClick(Sender: TObject);
begin
  case cb2.ItemIndex of
    0: F1:= ed1.text;
    1: F2:= ed1.text;
    2: F3:= ed1.text;
    3: F4:= ed1.text;
    4: F5:= ed1.text;
    5: F6:= ed1.text;
  end;
  LoadIni;
end;

end.
